"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("request");
var channel_1 = require("./channel");
var logger_1 = require("./logger");
var Viber = /** @class */ (function (_super) {
    __extends(Viber, _super);
    function Viber(params) {
        return _super.call(this, {
            homedir: params.homedir,
            uid: params.uid,
            platform: 'viber'
        }) || this;
    }
    Viber.prototype.accountInfo = function () {
        return new Promise(function (resolve) {
            var url = "https://chatapi.viber.com/pa/get_account_info";
            var options = {
                json: true,
                url: url,
                headers: {
                    "X-Viber-Auth-Token": process.env.RECIME_VIBER_ACCESS_TOKEN
                },
                body: {}
            };
            request(options, function (err, response, result) {
                resolve(result);
            });
        });
    };
    Viber.prototype.execute = function (body, parameters, handler) {
        var _this = this;
        return this.accountInfo().then(function (u) { return _this.sendMessage(u, body, handler); });
    };
    Viber.prototype.sendMessage = function (user, body, handler) {
        var _this = this;
        var method = "send_message";
        return new Promise(function (resolve, reject) {
            logger_1.Logger.init(_this.params).then(function (logger) {
                logger.incoming(body);
                var sender = body.sender || body.user;
                handler(_this.params.uid, body, "viber", function (result) {
                    result.receiver = sender.id;
                    result.tracking_data = _this.params.uid;
                    result.sender = {
                        name: user.name,
                        avatar: "https://icons.recime.io/" + _this.params.uid
                    };
                    result.type = result.type || "text";
                    var url = "https://chatapi.viber.com/pa/" + method;
                    var options = {
                        json: true,
                        url: url,
                        headers: {
                            "X-Viber-Auth-Token": process.env.RECIME_VIBER_ACCESS_TOKEN
                        },
                        body: result
                    };
                    request(options, function (err, response, result) {
                        logger.outgoing(options, result);
                        resolve({
                            success: true
                        });
                    });
                }, function (err) {
                    reject(err);
                });
            });
        });
    };
    return Viber;
}(channel_1.Channel));
exports.Viber = Viber;
