import request = require("request");

import {Channel} from './channel';
import {Logger} from "./logger";

export class Viber extends Channel {
    private logger: any;
   
    constructor(params: any){
        super({
            homedir : params.homedir,
            uid : params.uid,
            platform : 'viber'
        });
    }
    accountInfo(){
        return new Promise((resolve)=>{
            const url = `https://chatapi.viber.com/pa/get_account_info`;
            const options = {
                json : true,
                url : url,
                headers : {
                    "X-Viber-Auth-Token" : process.env.RECIME_VIBER_ACCESS_TOKEN
                },
                body : {}
            };
            request(options, (err, response, result)=>{
                resolve(result);
            });
        });
    }

    execute(body, parameters, handler){
        return this.accountInfo().then((u)=>this.sendMessage(u, body, handler));
    }

    sendMessage(user, body, handler){
        const method = "send_message";
        return new Promise((resolve, reject)=>{
            Logger.init(this.params).then((logger)=>{
                logger.incoming(body);

                const sender = body.sender || body.user;
                  
                handler(this.params.uid, body, "viber", (result)=>{
                    result.receiver = sender.id;
                    result.tracking_data = this.params.uid;
                    result.sender = {
                        name : user.name,
                        avatar : `https://icons.recime.io/${this.params.uid}`
                    };
                    result.type = result.type || "text";
                
                    const url = `https://chatapi.viber.com/pa/${method}`;
                    const options = {
                        json : true,
                        url : url,
                        headers : {
                            "X-Viber-Auth-Token" : process.env.RECIME_VIBER_ACCESS_TOKEN
                        },
                        body : result
                    };
                    request(options, (err, response, result)=>{
                        logger.outgoing(options, result);
                        resolve({
                            success : true
                        });
                    });
                }, (err)=> {
                    reject(err);
                });
            });
        });
    }
}